* PCMOUSE2ATARI handling
* by DarkDK 2008
* ver 1.0
; rda w formacia mads'a


;Procedury

; init

; wej: nie ma
; wyj: ustawiony port A do transmisji

; inicjuje port A do transmisji, wywoa raz na pocztku programu 
l
; wywoanie:
; jsr MOUSE.init


; exe_cmd_mouse

;wej: cmd - kod komendy
;     cmd_c - dugo odczytywego raportu (w bajtach)
;wyj: A=0 - nie wykonano, A=1 wykonano, w buffer znajduj si odczytane bajty 

; procedura wykonujca komendy PIC
; uwaga!! komendy musz by postaci xxx0xxx0 tzn. 0 i 4 bit rwne zero 
; 
; wywoanie mona umieci w przerwaniu VBL lub w gwnej ptli programu
; uwaga!! kod zosta napisany tak, aby zachowa minimalne opnienia pomidzy poszczeglnymi
; fazami dziaania procedury. Naley to uwzgldni podczas modyfikacji procedur.
; 
;wywoanie:
; mva #kod_komendy MOUSE.cmd
; mva #ilo_odbieranych_bajtw MOUSE.cmd_c
; jsr	MOUSE.exe_cmd_mouse


MOUSE	.LOCAL

PORTA  equ $d300
PACTL  equ $d302
TRIG0  equ $d010
TRIG1  equ $d011


buffer	.by 0 0 0 0 0 0 .LOCAL
cmd	dta 0
cmd_c	dta 0
temp    dta 0
trig_shadow dta 0
pota_shadow dta 0
potb_shadow dta 0

; inicjacja PORTA
init	.LOCAL
	lda PACTL
	and #$fb
	sta PACTL
	ldy #$ff	;PORTA output
	sty PORTA
	ora #$04
	sta PACTL
	lda #$ff
	sta PORTA
	rts
	.ENDL

;opnienie dla procedur odbiorczo-nadawczych
delay_regx .LOCAL
:3	stx PORTA  ;opnienie
	rts		; gdy jest wywoywane jako procedura wystarcz 3x stx porta
	.ENDL		; gdy bez procedury bezpiecznie jest ustawi na 5x stx porta
			; procedur t moemy zastpi swoj np. ktra wykonuje obliczenia
			; trzeba zapewni minimalny czas jej pracy (tyle cykli ile ma obecnie
			; cznie z czasem wykonania JSR i RTS)
			; drugim ograniczeniem jest maksymalny czas jaki moe upyn od
			; wysania komendy do odbioru ostatniego bajtu wynoszcy ok. 15ms

;odczyt bajtu z portu 0 joystica
gb4_0	.LOCAL
	lda PORTA
	and #$0e
	ora TRIG0
	ldx #$fe
	jsr delay_regx	;opnienie
	sta temp	 ;mlodszy nibble
	ldx #$ff
	stx PORTA
	lda PORTA
	and #$0e
	ora TRIG0
	ldx #$fe
	jsr delay_regx	;opnienie
	ldx #$ff
	stx PORTA
	asl @
	asl @
	asl @
	asl @
	ora temp
	rts
	.ENDL

;odczyt bajtu z portu 1 joystica
gb4_1	.LOCAL
	lda PORTA
	lsr @
	lsr @
	lsr @
	lsr @
	and #$0e
	ora TRIG1
	sta temp   ;mlodszy nibble
	ldx #$ef
	jsr delay_regx  ;opnienie
	ldx #$ff
	stx PORTA
	lda TRIG1
	lsr @
	lda PORTA
	and #$e0
	ldx #$ef
	jsr delay_regx  ;opnienie
	ldx #$ff
	stx PORTA
	bcc *+4
	ora #$10
	ora temp
	rts
	.ENDL

; procedura wykonujca komendy PIC
; uwaga!! komendy musz by postaci xxx0xxx0 tzn 0 i 4 bit rwne zero 
;wej: cmd - kod komendy
;     cmd_c - dugo odczytywego raportu (w bajtach)
;wyj: A=0 - nie wykonano, A=1 wykonano, w buffer znajduj si odczytane bajty

exe_cmd_mouse	.LOCAL

	; pic busy?	
	lda PORTA
	and #$f0
	cmp #$30
	beq mouse1
	lda PORTA
	and #$0f
	cmp #$03
	beq mouse0
	lda #$00	;nie wykonano komendy
	rts

;wykonanie komendy dla portu 0

mouse0:
	lda TRIG0
	sta trig_shadow; w tym miejscu najlepiej odczyta stan FIRE/ LEFT BUTTON MOUSE
	lda $270
	sta pota_shadow
	lda $271
	sta potb_shadow

	lda cmd
	ora #$f0
	tax
	jsr delay_regx
	ldx #$ff
	jsr delay_regx
	lda cmd
	lsr @
	lsr @
	lsr @
	lsr @
	ora #$f0
	tax
	jsr delay_regx
	ldx #$ff
	stx PORTA
	ldy #$00
_sq0	lda cmd_c
	beq _end0
	dec cmd_c
	jsr gb4_0
	sta buffer,y
	iny
	bpl _sq0
_end0	lda #$01
	rts

;wykonanie komendy dla portu 1
;wej: cmd - kod komendy
;     cmd_c - dugo odczytywego raportu (w bajtach)
mouse1:
	lda TRIG1
	sta trig_shadow	; w tym miejscu najlepiej odczyta stan FIRE/ LEFT BUTTON MOUSE
	lda $272
	sta pota_shadow
	lda $273
	sta potb_shadow

	lda cmd
	asl @
	asl @
	asl @
	asl @
	ora #$0f
	tax
	jsr delay_regx
	ldx #$ff
	jsr delay_regx
	lda cmd
	ora #$0f
	tax
	jsr delay_regx
	ldx #$ff
	stx PORTA
	ldy #$00
_sq1	lda cmd_c
	beq _end1
	dec cmd_c
	jsr gb4_1
	sta buffer,y
	iny
	bpl _sq1
_end1	lda #$01
	rts
	.ENDL ;update

;tablica dugoci komend
len_cmd
	.by 6	;cmd_switch_test_6B	;0x00
	.by 6	;cmd_switch_test_6B	;0x01
	.by 0	;			;0x02
	.by 6	;cmd_test_6B		;0x03
	.by 0	;			;0x04
	.by 6	;cmd_test_6B		;0x05
	.by 0	;			;0x06
	.by 6	;cmd_test_6B		;0x07
	.by 0	;			;0x08
	.by 6	;cmd_test_6B		;0x09
	.by 0	;			;0x0A
	.by 6	;cmd_test_6B		;0x0B
	.by 0	;			;0x0C
	.by 6	;cmd_test_6B		;0x0D
	.by 0	;			;0x0E
	.by 6	;cmd_test_6B		;0x0F


	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.by 2	;cmd_count_228_nwoc_2B		;0x20
	.by 6	;cmd_test_6B			;0x21	cmd test
	.by 2	;cmd_count_228_woc_2B		;0x22
	.by 6	;cmd_test_6B			;0x23	cmd test
	.by 2	;cmd_count_8bit_nwoc_2B		;0x24
	.by 6	;cmd_test_6B			;0x25	cmd test
	.by 2	;cmd_count_8bit_woc_2B		;0x26
	.by 6	;cmd_test_6B			;0x27	cmd test
	.by 3	;cmd_count_8bit_nwoc_3B		;0x28
	.by 6	;cmd_test_6B			;0x29	cmd test
	.by 3	;cmd_count_8bit_woc_3B		;0x2A
	.by 6	;cmd_test_6B			;0x2B	cmd test
	.by 4	;cmd_count_9bit_nwoc_4B		;0x2C
	.by 6	;cmd_test_6B			;0x2D	cmd test
	.by 4	;cmd_count_9bit_nwoc_4B		;0x2E
	.by 6	;cmd_test_6B			;0x2F	cmd test

	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.by 1	;cmd_get_raw_lenght_1B		;0x40
	.by 6	;cmd_test_6B			;0x41	cmd test
	.by 3	;cmd_get_raw_3B			;0x42
	.by 6	;cmd_test_6B			;0x43	cmd test
	.by 4	;cmd_get_raw_4B			;0x44
	.by 6	;cmd_test_6B			;0x45	cmd test
	.by 0					;0x46
	.by 6	;cmd_test_6B			;0x47	cmd test
	.by 6	;cmd_get_raw_6B			;0x48
	.by 6	;cmd_test_6B			;0x49	cmd test
	.by 0					;0x4A
	.by 6	;cmd_test_6B			;0x4B	cmd test
	.by 0					;0x4C
	.by 6	;cmd_test_6B			;0x4D	cmd test
	.by 0					;0x4E
	.by 6	;cmd_test_6B			;0x4F	cmd test

	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.by 1	;cmd_set_resolution1_1B		;0x60
	.by 6	;cmd_test_6B			;0x61	cmd test
	.by 1	;cmd_set_resolution2_1B		;0x62
	.by 6	;cmd_test_6B			;0x63	cmd test
	.by 1	;cmd_set_resolution4_1B		;0x64
	.by 6	;cmd_test_6B			;0x65	cmd test
	.by 1	;cmd_set_resolution8_1B		;0x66
	.by 6	;cmd_test_6B			;0x67	cmd test
	.by 0					;0x68
	.by 6	;cmd_test_6B			;0x69	cmd test
	.by 0					;0x6A
	.by 6	;cmd_test_6B			;0x6B	cmd test
	.by 0					;0x6C
	.by 6	;cmd_test_6B			;0x6D	cmd test
	.by 0					;0x6E
	.by 6	;cmd_test_6B			;0x6F	cmd test


	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.by 1	;cmd_get_id_device_1B		;0x80
	.by 6	;cmd_test_6B			;0x81	cmd test
	.by 3	;cmd_get_status_request_3B	;0x82
	.by 6	;cmd_test_6B			;0x83	cmd test
	.by 1	;cmd_software_version_1B	;0x84
	.by 6	;cmd_test_6B			;0x85	cmd test	
	.by 3	;cmd_test_00_55_AA_3B		;0x86
	.by 6	;cmd_test_6B			;0x87	cmd test
	.by 0					;0x88
	.by 6	;cmd_test_6B			;0x89	cmd test
	.by 0					;0x8A
	.by 6	;cmd_test_6B			;0x8B	cmd test
	.by 0					;0x8C
	.by 6	;cmd_test_6B			;0x8D	cmd test
	.by 0					;0x8E
	.by 6	;cmd_test_6B			;0x8F	cmd test


	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane


	.by 0					;0xA0
	.by 6	;cmd__test_6_bytes_4bit		;0xA1	cmd test
	.by 0					;0xA2
	.by 6	;cmd__test_6_bytes_4bit		;0xA3	cmd test
	.by 0					;0xA4
	.by 6	;cmd__test_6_bytes_4bit		;0xA5	cmd test
	.by 0					;0xA6
	.by 6	;cmd__test_6_bytes_4bit		;0xA7	cmd test
	.by 0					;0xA8
	.by 6	;cmd__test_6_bytes_4bit		;0xA9	cmd test
	.by 0					;0xAA
	.by 6	;cmd__test_6_bytes_4bit		;0xAB	cmd test
	.by 0					;0xAC
	.by 6	;cmd__test_6_bytes_4bit		;0xAD	cmd test
	.by 0					;0xAE
	.by 6	;cmd__test_6_bytes_4bit		;0xAF	cmd test

	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.by 0					;0xC0
	.by 6	;cmd__test_6_bytes_4bit		;0xC1	cmd test
	.by 0					;0xC2
	.by 6	;cmd__test_6_bytes_4bit		;0xC3	cmd test
	.by 0					;0xC4
	.by 6	;cmd__test_6_bytes_4bit		;0xC5	cmd test
	.by 0					;0xC6
	.by 6	;cmd__test_6_bytes_4bit		;0xC7	cmd test
	.by 0					;0xC8
	.by 6	;cmd__test_6_bytes_4bit		;0xC9	cmd test
	.by 0					;0xCA
	.by 6	;cmd__test_6_bytes_4bit		;0xCB	cmd test
	.by 0					;0xCC
	.by 6	;cmd__test_6_bytes_4bit		;0xCD	cmd test
	.by 0					;0xCE
	.by 6	;cmd__test_6_bytes_4bit		;0xCF	cmd test


	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.by 0					;0xE0
	.by 6	;cmd__test_6_bytes_4bit		;0xE1	cmd test
	.by 0					;0xE2
	.by 6	;cmd__test_6_bytes_4bit		;0xE3	cmd test
	.by 0					;0xE4
	.by 6	;cmd__test_6_bytes_4bit		;0xE5	cmd test
	.by 0					;0xE6
	.by 6	;cmd__test_6_bytes_4bit		;0xE7	cmd test
	.by 0					;0xE8
	.by 6	;cmd__test_6_bytes_4bit		;0xE9	cmd test
	.by 0					;0xEA
	.by 6	;cmd__test_6_bytes_4bit		;0xEB	cmd test
	.by 0					;0xEC
	.by 6	;cmd__test_6_bytes_4bit		;0xED	cmd test
	.by 0					;0xEE
	.by 6	;cmd__test_6_bytes_4bit		;0xEF	cmd test

	.by 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0	;kody niewykorzystane

	.ENDL ; MOUSE